<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `&#x2F;nix&#x2F;store&#x2F;klw0pjcx3gcsqz561gi1wwv8hj1lg84w-vendored-sources&#x2F;syn-1.0.86&#x2F;src&#x2F;spanned.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>spanned.rs - source</title><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled ><script id="default-settings" ></script><script src="../../storage.js"></script><script src="../../crates.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"><style type="text/css">#crate-search{background-image:url("../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu" role="button">&#9776;</div><a href='../../syn/index.html'><div class='logo-container rust-logo'><img src='../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu" title="themes"><img width="18" height="18" alt="Pick another theme!" src="../../brush.svg"></button><div id="theme-choices" role="menu"></div></div><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" id="help-button" title="help">?</button><a id="settings-menu" href="../../settings.html" title="settings"><img width="18" height="18" alt="Change settings" src="../../wheel.svg"></a></div></form></nav><section id="main" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">  1</span>
<span id="2">  2</span>
<span id="3">  3</span>
<span id="4">  4</span>
<span id="5">  5</span>
<span id="6">  6</span>
<span id="7">  7</span>
<span id="8">  8</span>
<span id="9">  9</span>
<span id="10"> 10</span>
<span id="11"> 11</span>
<span id="12"> 12</span>
<span id="13"> 13</span>
<span id="14"> 14</span>
<span id="15"> 15</span>
<span id="16"> 16</span>
<span id="17"> 17</span>
<span id="18"> 18</span>
<span id="19"> 19</span>
<span id="20"> 20</span>
<span id="21"> 21</span>
<span id="22"> 22</span>
<span id="23"> 23</span>
<span id="24"> 24</span>
<span id="25"> 25</span>
<span id="26"> 26</span>
<span id="27"> 27</span>
<span id="28"> 28</span>
<span id="29"> 29</span>
<span id="30"> 30</span>
<span id="31"> 31</span>
<span id="32"> 32</span>
<span id="33"> 33</span>
<span id="34"> 34</span>
<span id="35"> 35</span>
<span id="36"> 36</span>
<span id="37"> 37</span>
<span id="38"> 38</span>
<span id="39"> 39</span>
<span id="40"> 40</span>
<span id="41"> 41</span>
<span id="42"> 42</span>
<span id="43"> 43</span>
<span id="44"> 44</span>
<span id="45"> 45</span>
<span id="46"> 46</span>
<span id="47"> 47</span>
<span id="48"> 48</span>
<span id="49"> 49</span>
<span id="50"> 50</span>
<span id="51"> 51</span>
<span id="52"> 52</span>
<span id="53"> 53</span>
<span id="54"> 54</span>
<span id="55"> 55</span>
<span id="56"> 56</span>
<span id="57"> 57</span>
<span id="58"> 58</span>
<span id="59"> 59</span>
<span id="60"> 60</span>
<span id="61"> 61</span>
<span id="62"> 62</span>
<span id="63"> 63</span>
<span id="64"> 64</span>
<span id="65"> 65</span>
<span id="66"> 66</span>
<span id="67"> 67</span>
<span id="68"> 68</span>
<span id="69"> 69</span>
<span id="70"> 70</span>
<span id="71"> 71</span>
<span id="72"> 72</span>
<span id="73"> 73</span>
<span id="74"> 74</span>
<span id="75"> 75</span>
<span id="76"> 76</span>
<span id="77"> 77</span>
<span id="78"> 78</span>
<span id="79"> 79</span>
<span id="80"> 80</span>
<span id="81"> 81</span>
<span id="82"> 82</span>
<span id="83"> 83</span>
<span id="84"> 84</span>
<span id="85"> 85</span>
<span id="86"> 86</span>
<span id="87"> 87</span>
<span id="88"> 88</span>
<span id="89"> 89</span>
<span id="90"> 90</span>
<span id="91"> 91</span>
<span id="92"> 92</span>
<span id="93"> 93</span>
<span id="94"> 94</span>
<span id="95"> 95</span>
<span id="96"> 96</span>
<span id="97"> 97</span>
<span id="98"> 98</span>
<span id="99"> 99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
</pre><pre class="rust"><code><span class="doccomment">//! A trait that can provide the `Span` of the complete contents of a syntax</span>
<span class="doccomment">//! tree node.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! *This module is available only if Syn is built with both the `&quot;parsing&quot;` and</span>
<span class="doccomment">//! `&quot;printing&quot;` features.*</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! &lt;br&gt;</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! # Example</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! Suppose in a procedural macro we have a [`Type`] that we want to assert</span>
<span class="doccomment">//! implements the [`Sync`] trait. Maybe this is the type of one of the fields</span>
<span class="doccomment">//! of a struct for which we are deriving a trait implementation, and we need to</span>
<span class="doccomment">//! be able to pass a reference to one of those fields across threads.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! [`Type`]: crate::Type</span>
<span class="doccomment">//! [`Sync`]: std::marker::Sync</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! If the field type does *not* implement `Sync` as required, we want the</span>
<span class="doccomment">//! compiler to report an error pointing out exactly which type it was.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! The following macro code takes a variable `ty` of type `Type` and produces a</span>
<span class="doccomment">//! static assertion that `Sync` is implemented for that type.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ```</span>
<span class="doccomment">//! # extern crate proc_macro;</span>
<span class="doccomment">//! #</span>
<span class="doccomment">//! use proc_macro::TokenStream;</span>
<span class="doccomment">//! use proc_macro2::Span;</span>
<span class="doccomment">//! use quote::quote_spanned;</span>
<span class="doccomment">//! use syn::Type;</span>
<span class="doccomment">//! use syn::spanned::Spanned;</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! # const IGNORE_TOKENS: &amp;str = stringify! {</span>
<span class="doccomment">//! #[proc_macro_derive(MyMacro)]</span>
<span class="doccomment">//! # };</span>
<span class="doccomment">//! pub fn my_macro(input: TokenStream) -&gt; TokenStream {</span>
<span class="doccomment">//!     # let ty = get_a_type();</span>
<span class="doccomment">//!     /* ... */</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!     let assert_sync = quote_spanned! {ty.span()=&gt;</span>
<span class="doccomment">//!         struct _AssertSync where #ty: Sync;</span>
<span class="doccomment">//!     };</span>
<span class="doccomment">//!</span>
<span class="doccomment">//!     /* ... */</span>
<span class="doccomment">//!     # input</span>
<span class="doccomment">//! }</span>
<span class="doccomment">//! #</span>
<span class="doccomment">//! # fn get_a_type() -&gt; Type {</span>
<span class="doccomment">//! #     unimplemented!()</span>
<span class="doccomment">//! # }</span>
<span class="doccomment">//! ```</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! By inserting this `assert_sync` fragment into the output code generated by</span>
<span class="doccomment">//! our macro, the user&#39;s code will fail to compile if `ty` does not implement</span>
<span class="doccomment">//! `Sync`. The errors they would see look like the following.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ```text</span>
<span class="doccomment">//! error[E0277]: the trait bound `*const i32: std::marker::Sync` is not satisfied</span>
<span class="doccomment">//!   --&gt; src/main.rs:10:21</span>
<span class="doccomment">//!    |</span>
<span class="doccomment">//! 10 |     bad_field: *const i32,</span>
<span class="doccomment">//!    |                ^^^^^^^^^^ `*const i32` cannot be shared between threads safely</span>
<span class="doccomment">//! ```</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! In this technique, using the `Type`&#39;s span for the error message makes the</span>
<span class="doccomment">//! error appear in the correct place underlining the right type.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! &lt;br&gt;</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! # Limitations</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! The underlying [`proc_macro::Span::join`] method is nightly-only. When</span>
<span class="doccomment">//! called from within a procedural macro in a nightly compiler, `Spanned` will</span>
<span class="doccomment">//! use `join` to produce the intended span. When not using a nightly compiler,</span>
<span class="doccomment">//! only the span of the *first token* of the syntax tree node is returned.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! In the common case of wanting to use the joined span as the span of a</span>
<span class="doccomment">//! `syn::Error`, consider instead using [`syn::Error::new_spanned`] which is</span>
<span class="doccomment">//! able to span the error correctly under the complete syntax tree node without</span>
<span class="doccomment">//! needing the unstable `join`.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! [`syn::Error::new_spanned`]: crate::Error::new_spanned</span>

<span class="kw">use</span> <span class="ident">proc_macro2::Span</span>;
<span class="kw">use</span> <span class="ident">quote::spanned::Spanned</span> <span class="kw">as</span> <span class="ident">ToTokens</span>;

<span class="doccomment">/// A trait that can provide the `Span` of the complete contents of a syntax</span>
<span class="doccomment">/// tree node.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This trait is automatically implemented for all types that implement</span>
<span class="doccomment">/// [`ToTokens`] from the `quote` crate, as well as for `Span` itself.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// [`ToTokens`]: quote::ToTokens</span>
<span class="doccomment">///</span>
<span class="doccomment">/// See the [module documentation] for an example.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// [module documentation]: self</span>
<span class="doccomment">///</span>
<span class="doccomment">/// *This trait is available only if Syn is built with both the `&quot;parsing&quot;` and</span>
<span class="doccomment">/// `&quot;printing&quot;` features.*</span>
<span class="kw">pub</span> <span class="kw">trait</span> <span class="ident">Spanned</span> {
    <span class="doccomment">/// Returns a `Span` covering the complete contents of this syntax tree</span>
    <span class="doccomment">/// node, or [`Span::call_site()`] if this node is empty.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// [`Span::call_site()`]: proc_macro2::Span::call_site</span>
    <span class="kw">fn</span> <span class="ident">span</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">Span</span>;
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="question-mark">?</span><span class="ident">Sized</span> <span class="op">+</span> <span class="ident">ToTokens</span><span class="op">&gt;</span> <span class="ident">Spanned</span> <span class="kw">for</span> <span class="ident">T</span> {
    <span class="kw">fn</span> <span class="ident">span</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">Span</span> {
        <span class="self">self</span>.<span class="ident">__span</span>()
    }
}
</code></pre></div>
</section><section id="search" class="content hidden"></section><div id="rustdoc-vars" data-root-path="../../" data-current-crate="syn" data-search-index-js="../../search-index.js" data-search-js="../../search.js"></div>
    <script src="../../main.js"></script><script src="../../source-script.js"></script><script src="../../source-files.js"></script>
</body></html>